'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.GenericDetailController = exports.GenericListController = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GenericListController = function () {
    function GenericListController($scope, $location, $stateParams, $state, records) {
        var _this = this;

        _classCallCheck(this, GenericListController);

        this.$location = $location;
        this.$stateParams = $stateParams;
        this.$state = $state;
        this.meta = records.meta;
        this.records = records;
        this.itemsPerPage = this.getItemsPerPage();

        this.paginated = $state.$current.params.page !== undefined || records.meta.count;

        if (this.paginated) {
            $scope.$watch(function () {
                return _this.itemsPerPage;
            }, function (newValue, oldValue) {
                if (oldValue != newValue) {
                    _this.$location.search('page_size', newValue);
                }
            });
        }
    }

    _createClass(GenericListController, [{
        key: 'getItemsPerPage',
        value: function getItemsPerPage() {
            return +this.$location.search().page_size || 5;
        }
    }, {
        key: 'hasPreviousPage',
        value: function hasPreviousPage() {
            return this.meta.previous != null;
        }
    }, {
        key: 'hasNextPage',
        value: function hasNextPage() {
            return this.meta.next != null;
        }
    }, {
        key: 'nextPage',
        value: function nextPage() {
            var page = (+this.$stateParams.page || 1) + 1;
            return this.$state.$current.name + '({ page: ' + page + ' })';
        }
    }, {
        key: 'previousPage',
        value: function previousPage() {
            var page = this.$stateParams.page - 1;
            return this.$state.$current.name + '({ page: ' + page + ' })';
        }
    }]);

    return GenericListController;
}();

GenericListController.prototype.itemsPerPageOptions = [5, 10, 25, 50, 75, 100];

GenericListController.$inject = ['$scope', '$location', '$stateParams', '$state', 'records'];

var GenericDetailController = function () {
    function GenericDetailController($stateParams, $state, record) {
        _classCallCheck(this, GenericDetailController);

        this.$stateParams = $stateParams;
        this.$state = $state;
        this.resource = record;
        if (this.exists) {
            this.record = record;
        } else {
            this.record = {};
        }
        window.$state = $state;
    }

    _createClass(GenericDetailController, [{
        key: 'create',
        value: function create() {
            var _this2 = this;

            return this.resource.post(this.record).then(function (record) {
                return _this2.redirect(_this2.redirectTo);
            });
        }
    }, {
        key: 'update',
        value: function update(_ref) {
            var _this3 = this;

            var fields = _ref.fields;
            var excludedFields = _ref.excludedFields;

            var clonedRecord = angular.copy(this.record);
            // TODO filter Out fields from the update
            return clonedRecord.patch().then(function (record) {
                return _this3.redirect(_this3.redirectTo);
            });
        }
    }, {
        key: 'redirect',
        value: function redirect() {
            var to = arguments.length <= 0 || arguments[0] === undefined ? this.detailRoute : arguments[0];

            this.$state.go(to, this.$stateParams);
        }
    }, {
        key: 'exists',
        get: function get() {
            return !!this.resource.id;
        }
    }, {
        key: 'save',
        get: function get() {
            return this.exists ? this.update : this.create;
        }
    }, {
        key: 'detailRoute',
        get: function get() {
            return this.$state.current.data.routeDefinition.view;
        }
    }, {
        key: 'fields',
        get: function get() {
            if (!_lodash2.default.get(this.resource, '$meta.$object.actions')) return;

            var fields = {};

            if (!this.exists) {
                fields.options = this.resource.$meta.$object.actions.POST;
            } else {
                fields.options = this.resource.$meta.$object.actions.PUT || this.resource.$meta.$object.actions.PATCH;
            }

            fields.fieldNames = Object.keys(fields.options);

            return fields;
        }
    }]);

    return GenericDetailController;
}();

GenericDetailController.$inject = ['$stateParams', '$state', 'record'];

exports.GenericListController = GenericListController;
exports.GenericDetailController = GenericDetailController;